import threading
from pathlib import Path

from django.core.exceptions import ImproperlyConfigured



class CommandData:

    def __init__(self, **kwargs):
        for k, v in kwargs.items():
            setattr(self, k, v)


class Argument:
    def __init__(self, *args, **kwargs):
        self.args = args
        self.kwargs = kwargs




class ThreadWrapper(threading.Thread):

    def __init__(self, fct):
        super().__init__()
        self.fct = fct

    def run(self) -> None:
        return self.fct()


class BaseCommandMxin:

    NAME = None
    HELP = None
    ALIASES = []

    ARGUMENT=None
    parser = None
    def __init__(self):
        pass

    def execute(self, data):
        return self.run(data)

    def run(self, data):
        raise NotImplementedError()

    def print_help(self):
        self.parser.print_help()

class Command(BaseCommandMxin):

    @classmethod
    def thread_run(cls, data):
        cmd = cls()
        dd = {cmd.NAME: data}
        thread = ThreadWrapper(lambda x=dd: cmd.run(x))
        thread.start()
        return thread


    @staticmethod
    def load(commands_dirs=None):

        from djangotools.common.module_loader import iter_module_content
        ret = {}
        for name, val in  iter_module_content(commands_dirs, classe=Command):
            if val.NAME:
                ret[val.NAME] = val

        return set(ret.values())




class SubCommand(BaseCommandMxin):

    def __init__(self, name=None, aliases=None, help=None, arguments=None, fct=None):
        super().__init__()
        self.NAME = name or self.NAME
        self.HELP = help or self.HELP
        self.ALIASES = aliases or self.ALIASES
        self.ARGUMENT = arguments or self.ARGUMENT
        self.fct=fct

    def __call__(self, *args, **kwargs):
        return self


