from django.contrib.auth import login
from django.contrib.auth.models import User

from django.conf import settings

def debug_login(request, fallback_id=None):
    if settings.ALLOW_AUTO_LOGIN and not request.user.is_authenticated and settings.AUTO_LOGIN:
        try:
            user = User.objects.get(username=settings.AUTO_LOGIN)
        except User.DoesNotExist:
            if fallback_id is not None:
                user = User.objects.get(id=fallback_id)
            else:
                raise Exception()
        login(request, user)


def check_auth(request):
    debug_login(request)
    return request.user.is_authenticated
