from collections import defaultdict

from django.apps import apps
from django.db.models.base import ModelBase, Model

from django.db import models


class Manager(models.Manager):
    def create_from_json(self, **kwargs):
        return self.create(**kwargs)


class BaseSerializationModel:
    pass


class UserIdManager(Manager):
    def get_item(self, id, user, **kwargs):
        return super().get(id=int(id),user=user, **kwargs)

def all_models(app=None):
    if app:
        return apps.all_models[app]
    return app.all_models


def iter_models(app=None):
    if app:
        return apps.all_models[app].values()
    for app, models in apps.all_models.items():
        for model in models.values():
            yield model

def iter_models_items(app=None):
    if app:
        return apps.all_models[app].items()
    for app, models in apps.all_models.items():
        for x in models.items():
            yield x

def get_model(name, app=None):
    if isinstance(name, ModelBase):
        return name
    name = name.lower()
    if app is not None: return apps.all_models[app][name]
    for _, models in apps.all_models.items():
        if name in models:
            return models[name]
    raise ValueError(f"Impossible de trouver le model {name}")